> module BTFun where
> import Prelude hiding (span, head, tail)
> import Rank1
> import Rank2

Binary trees without content.

> data BTF a = Leaf | Span {left :: a, right :: a}
>
> instance Functor BTF where
>     fmap f Leaf = Leaf
>     fmap f (Span t u) = Span (f t) (f u)
>
> type BT = Mu1 BTF
>
> leaf :: BT
> leaf = In1 Leaf
>
> span :: BT -> BT -> BT
> span t u = In1 (Span t u)

Functions over binary trees as coinductive datatype. (Thorsten Altenkirch)

> data TFunF f a = Cons { hd :: a, tl :: (f (f a)) }
>
> instance Functor2 TFunF where
>     ffmap s f (Cons a t) = Cons (f a) (s (s f) t)
>
> type TFun a = Nu2 TFunF a

Destructors.

> head :: TFun a -> a
> head b = hd (out b)
>
> tail :: TFun a -> TFun (TFun a)
> tail b = tl (out b)

Creating a TFun from a function over BT by coiteration.

> newtype BTto a = BTto (BT -> a)

> stepLam :: BTto a -> TFunF BTto a
> stepLam (BTto f) = Cons (f leaf) (BTto (\t -> BTto (\u -> f (span t u))))
>
> lamBT' :: (a -> b) -> (BT -> a) -> TFun b
> lamBT' f g = Coit stepLam f (BTto g)
>
> lamBT :: (BT -> a) -> TFun a
> lamBT g = lamBT' id g

Applying a TFun to a BT.

> newtype TFto = TFto (forall a. TFun a -> a)

> stepApp :: BTF TFto -> TFto
> stepApp Leaf                     = TFto (\b -> head b)
> stepApp (Span (TFto l) (TFto r)) = TFto (\b -> r (l (tail b)))

> appBT :: BT -> TFun a -> a
> appBT t = g where (TFto g) = it1 stepApp t
